//FarbeErsetzen_302d.js
// 12.01.13 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Zugewiesene Farbe durch andere ersetzen

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// prfen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// sicherstellen, dass keine Musterseite angezeigt ist
if (app.activeWindow.activeSpread.constructor.name == "MasterSpread") {
	alert ("Funktioniert nicht mit Mustervorlagen.", "Stop");
	exit ();
}

// die Version speichern
var appVers = (app.version[0])*1;

// die Namen der fixen Farbfelder definieren
noColor    = "[None]";
regisColor = "[Registration]";
paperColor = "[Paper]";
blackColor = "[Black]";

// die Sprache des Programms speichern
var curLang = (app.locale)*1;

// die Namen der Farbfelder vorbereiten (in FR and DE)
if (curLang   == 1279477362) { // = Franzsisch
	noColor      = "[Sans]";
	regisColor   = "[Reprage]";
	paperColor   = "[Papier]";
	blackColor   = "[Noir]";
	if (appVers == 4) {
		noColor    = "[Aucun]";
	}
}
else if (curLang == 1279477613) { // = Deutsch
	noColor      = "[Ohne]";
	regisColor   = "[Passermarken]";
	paperColor   = "[Papier]";
	blackColor   = "[Schwarz]";
	if (appVers == 4) {
		noColor    = "[Keine]";
		regisColor = "[Passkreuze]";
	}
}
// das Dokument im Vordergrund
var curDoc = app.documents[0];

// die Farbfelder des Dokuments
allSwatches = curDoc.swatches;

// eine eventuelle Auswahl prfen
var noSel  = true;
var oColor = "";
if (app.selection.length != 0) {
	var baseColors = "|Black|Paper|Registration|None|";
	try {
		var selColorStrk = app.selection[0].strokeColor.name;
		var testStrkName = "|" + selColorStrk + "|";
		if (app.selection[0].constructor.name != "GraphicLine") {
			var selColorFill = app.selection[0].fillColor.name;
			var testFillName = "|" + selColorFill + "|";
			if (baseColors.indexOf(testFillName) == -1) {
				oColor = selColorFill;
			}
		}
		if (oColor == "") {
			if (baseColors.indexOf(testStrkName) == -1) {
				oColor = selColorStrk;
			}
		}
		noSel = false;
	}
	catch (e) {
	}
}

// die Checkboxenwerte vorbereiten
ck00 = ck01 = ck02 = ck03 = ck04 = ck05 = ck06 = ck07 = ck08 = ck09 = ck10 = ck11 = 0;

// die Liste der Seitennummern
allPageNames = app.documents[0].pages.everyItem().name;

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	if (noSel == false && oColor != "") {
		oName = oColor;
	}
	else {
		var oName = prefVal[0];
		if      (oName == "Black") { oName = blackColor; }
		else if (oName == "Paper") { oName = paperColor; }
		else if (oName == "Registration") { oName = regisColor; }
		else if (oName == "None")  { oName = noColor; }
	}
	var nName = prefVal[1];
	if      (nName == "Black") { nName = blackColor; }
	else if (nName == "Paper") { nName = paperColor; }
	else if (nName == "Registration") { nName = regisColor; }
	else if (nName == "None")  { nName = noColor; }
	pNum = prefVal[2];
	var okay = rangeOfPages(pNum, true);
	if (okay == false) {
		if (noSel == false) {
			try {
				curPage = findPage(app.selection[0]);
				pNum = curPage.name;
			}
			catch (e) {
				try {
					pNum = app.activeWindow.activePage.name;
				}
				catch (e) {
					pNum = allPageNames[0];
				}
			}
		}
		else {
			try {
				pNum = app.activeWindow.activePage.name;
			}
			catch (e) {
				pNum = allPageNames[0];
			}
		}
	}
	var cb00 = prefVal[3];
	if (cb00 == "true") { ck00 = 1; }
	var cb01 = prefVal[4];
	if (cb01 == "true") { ck01 = 1; }
	var cb02 = prefVal[5];
	if (cb02 == "true") { ck02 = 1; }
	var cb03 = prefVal[6];
	if (cb03 == "true") { ck03 = 1; }
	var cb04 = prefVal[7];
	if (cb04 == "true") { ck04 = 1; }
	var cb05 = prefVal[8];
	if (cb05 == "true") { ck05 = 1; }
	var cb06 = prefVal[9];
	if (cb06 == "true") { ck06 = 1; }
	var cb07 = prefVal[10];
	if (cb07 == "true") { ck07 = 1; }
	var cb08 = prefVal[11];
	if (cb08 == "true") { ck08 = 1; }
	var cb09 = prefVal[12];
	if (cb09 == "true") { ck09 = 1; }
	var cb10 = prefVal[13];
	if (cb10 == "true") { ck10 = 1; }
	var cb11 = prefVal[14];
	if (cb11 == "true") { ck11 = 1; }
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde
	// dann auf die Vorgabenwerte zurckgreifen
	ck00 = 1;
	ck01 = 1;
	ck02 = 0;
	ck03 = 1;
	ck04 = 1;
	ck05 = 1;
	ck06 = 1;
	ck07 = 0;
	ck08 = 0;
	ck09 = 0;
	ck10 = 0;
	ck11 = 0;
	if (noSel == false && oColor != "") {
		oName = oColor;
	}
	else {
		oName = blackColor;
	}
	nName = blackColor;
	if (noSel == false) {
		try {
			curPage = findPage(app.selection[0]);
			pNum = curPage.name;
		}
		catch (e) {
			try {
				pNum = app.activeWindow.activePage.name;
			}
			catch (e) {
				pNum = allPageNames[0];
			}
		}
	}
	else {
		try {
			pNum = app.activeWindow.activePage.name;
		}
		catch (e) {
			pNum = allPageNames[0];
		}
	}
}

// die Funktionen aufrufen, welche die Listen der Farben vorbereiten
var oldColor = getOldColorList(oName);
var oldCol   = oldColor[0];
var oInd     = oldColor[1];
var newColor = getNewColorList(nName);
var newCol   = newColor[0];
var nInd     = newColor[1];

// die Funktion aufrufen, welche den Dialog zeigt und auswertet
var anArray = displayDialog();
var oColor  = anArray[0];
var nColor  = anArray[1];
var pNum    = anArray[2];
var ck00    = anArray[3];
var ck01    = anArray[4];
var ck02    = anArray[5];
var ck03    = anArray[6];
var ck04    = anArray[7];
var ck05    = anArray[8];
var ck06    = anArray[9];
var ck07    = anArray[10];
var ck08    = anArray[11];
var ck09    = anArray[12];
var ck10    = anArray[13];
var ck11    = anArray[14];

// die gewhlten Farbfelder vergleichen
if (oColor == nColor) {
	alert ("Alte und neue Farbe sind identisch.", "Stop");
	exit();
}

// die Eingabe prfen lassen
allPages = rangeOfPages(pNum, false);

// das Auffrischen abstellen
app.scriptPreferences.enableRedraw = false;

// eine Schleife durch die Seiten
for (var p=0; p<allPages.length; p++) {
	// die Funktion aufrufen, welche den Austausch der Farben vornimmt
	changeColor(oColor, nColor, allPages[p]);
}

// das Auffrischen wieder einschalten
app.scriptPreferences.enableRedraw = true;

// das Ende der Aktion verknden
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(999);
// das Fenster schliessen
dlog.close();


////////////////////////////// die Funktionen  ////////////////////////////////////////////////////

// die Funktion, welche die Informationen vorbereitet /////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/farbeersetzen302.txt");
	}
	else {
		var f = new File("~/Library/Preferences/farbeersetzen302.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// die Funktion, welche die Liste der "alten" Farben vorbereitet //////////////////////////////////
function getOldColorList(oName) {	
	// prfen, ob die Vorgabefarbe existiert
	if (oName != noColor && oName != regisColor && oName != paperColor && oName != blackColor) {
		try {
			curDoc.swatches.itemByName(oName).name;
		}
		catch (e) {
			oName = blackColor;
		}
	}
	// die Liste der Farben zusammenstellen;
	// "None", "Paper", "Black" und "Registration" umbenennen;
	// die Position der Vorgabefarbe feststellen
	var oldColorList = new Array();
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = paperColor;
		}
		else if (cName == "Black") {
			cName = blackColor;
		}
		else if (cName == "Registration") {
			cName = regisColor;
		}
		if (oName == cName) {
			oIndex = i;
		}
		oldColorList.push(cName);
	}
	return [oldColorList, oIndex];
}

// die Funktion, welche die Liste der "neuen" Farben vorbereitet //////////////////////////////////
function getNewColorList(nName) {	
	// prfen, ob die Vorgabefarbe existiert
	if (nName != noColor && nName != regisColor && nName != paperColor && nName != blackColor) {
		try {
			curDoc.swatches.itemByName(nName).name;
		}
		catch (e) {
			nName = blackColor;
		}
	}
	// die Liste der Farben zusammenstellen;
	// "None", "Paper", "Black" und "Registration" umbenennen;
	// die Position der Vorgabefarbe feststellen
	var oldColorList = new Array();
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = paperColor;
		}
		else if (cName == "Black") {
			cName = blackColor;
		}
		else if (cName == "Registration") {
			cName = regisColor;
		}
		if (nName == cName) {
			oIndex = i;
		}
		oldColorList.push(cName);
	}
	return [oldColorList, oIndex];
}

// den Dialog vorbereiten und anzeigen ////////////////////////////////////////////////////////////
function displayDialog() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth =  70;
	var fieldWidth = 236;
	var aDialog = app.dialogs.add({name:"FarbeErsetzen"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Zugewiesenes Farbfeld ...", minWidth:labelWidth-10});
						staticTexts.add({staticLabel:" "});
					}
					var oldColor = dropdowns.add({stringList:oldCol, selectedIndex:oInd, minWidth:130});
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"... mit diesem ersetzen", minWidth:labelWidth-10});
						staticTexts.add({staticLabel:" "});
					}
					var newColor = dropdowns.add({stringList:newCol, selectedIndex:nInd, minWidth:130});
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Seitenbereich(e) (z.B. 1, 2-3, 4-7):"});
				staticTexts.add({staticLabel:" ", minWidth:10});
			}
			with (dialogRows.add()) {
				var pagesField = textEditboxes.add({editContents:pNum, minWidth:fieldWidth});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Folgende Objekte behandeln:"});
				staticTexts.add({staticLabel:" ", minWidth:10});
			}
			with (dialogRows.add()) {
				var checkbox00 = checkboxControls.add({staticLabel:"Fllung", checkedState:ck00, minWidth:84});
				var checkbox01 = checkboxControls.add({staticLabel:"Kontur", checkedState:ck01, minWidth:84});
				var checkbox02 = checkboxControls.add({staticLabel:"Lcke", checkedState:ck02});
			}
			with (dialogRows.add()) {
				var checkbox03 = checkboxControls.add({staticLabel:"Bildrahmen", checkedState:ck03, minWidth:130});
				var checkbox04 = checkboxControls.add({staticLabel:"Textrahmen", checkedState:ck04});
			}
			with (dialogRows.add()) {
				var checkbox05 = checkboxControls.add({staticLabel:"Grafikrahmen", checkedState:ck05, minWidth:130});
				var checkbox06 = checkboxControls.add({staticLabel:"Linienrahmen", checkedState:ck06});
			}
			with (dialogRows.add()) {
				var checkbox07 = checkboxControls.add({staticLabel:"Tabellen", checkedState:ck07, minWidth:130});
				var checkbox08 = checkboxControls.add({staticLabel:"Texte", checkedState:ck08});
			}
			with (dialogRows.add()) {
				var checkbox09 = checkboxControls.add({staticLabel:"Absatzlinien", checkedState:ck09, minWidth:130});
				var checkbox10 = checkboxControls.add({staticLabel:"Unterstreichungen", checkedState:ck10});
			}
			with (dialogRows.add()) {
				var checkbox11 = checkboxControls.add({staticLabel:"Effekte (Schlagschatten usw.)", checkedState:ck11});
			}
		}
	}
	if(aDialog.show() == true) {
		oldIndex = oldColor.selectedIndex;
		oColor = curDoc.swatches[oldIndex].name;
		if      (oColor == blackColor) { oColor = "Black"; }
		else if (oColor == paperColor) { oColor = "Paper"; }
		else if (oColor == regisColor) { oColor = "Registration"; }
		else if (oColor == noColor)    { oColor = "None"; }
		newIndex = newColor.selectedIndex;
		nColor = curDoc.swatches[newIndex].name;
		if      (nColor == blackColor) { nColor = "Black"; }
		else if (nColor == paperColor) { nColor = "Paper"; }
		else if (nColor == regisColor) { nColor = "Registration"; }
		else if (nColor == noColor)    { nColor = "None"; }
		pNum = pagesField.editContents;
		cb00 = checkbox00.checkedState;
		cb01 = checkbox01.checkedState;
		cb02 = checkbox02.checkedState;
		cb03 = checkbox03.checkedState;
		cb04 = checkbox04.checkedState;
		cb05 = checkbox05.checkedState;
		cb06 = checkbox06.checkedState;
		cb07 = checkbox07.checkedState;
		cb08 = checkbox08.checkedState;
		cb09 = checkbox09.checkedState;
		cb10 = checkbox10.checkedState;
		cb11 = checkbox11.checkedState;
		aDialog.destroy();
		var prefsList = new Array (oColor, nColor, pNum, cb00, cb01, cb02, cb03, cb04, cb05, cb06, cb07, cb08, cb09, cb10, cb11);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		if (pNum == "") {
			alert ("Seitenbereich(e): Das Eingabefeld ist leer.", "Stop");
			exit();
		}
		return [oColor, nColor, pNum, cb00, cb01, cb02, cb03, cb04, cb05, cb06, cb07, cb08, cb09, cb10, cb11];
	}
	else{
		aDialog.destroy();
		exit();
	}
}

// das Ergebnis in eine Datei schreiben ///////////////////////////////////////////////////////////
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/farbeersetzen302.txt");
	}
	else {
		var f = File("~/Library/Preferences/farbeersetzen302.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// die Seitennummer herausfinden //////////////////////////////////////////////////////////////////
function findPage(curObj) {
	if (curObj.hasOwnProperty("baseline")) {
		curObj = curObj.parentTextFrames[0];
	}
	while (curObj != null) {
		if (curObj.hasOwnProperty ("parentPage")) {
			return curObj.parentPage;
		}
		var whatIsIt = curObj.constructor;
		switch (whatIsIt) {
			case Page : return curObj;
			case Character : curObj = curObj.parentTextFrames[0]; break;
			case Footnote  : ; // durchfallen
			case Cell : curObj = curObj.insertionPoints[0].parentTextFrames[0]; break;
			case Note : curObj = curObj.storyOffset.parentTextFrames[0]; break;
			case XMLElement  : if (curObj.insertionPoints[0] != null) { curObj = curObj.insertionPoints[0].parentTextFrames[0]; break; }
			case Application : return null;
			default: curObj = curObj.parent;
		}
		if (curObj == null) {
			return null;
		}
	}
	return curObj;
}

// die Liste der Seitenzahlen aufstellen und prfen ///////////////////////////////////////////////
function rangeOfPages(pageRange, pre) {
	var whatKind = 0;
	var startPagesList = new Array ();
	var stopPagesList  = new Array ();
	var pagesList      = new Array ();
	// Leerschlge entfernen
	var newRange = pageRange.split(" ");
	newRange = newRange.join("");
	// prfen, ob Kommas und/oder Bindestriche enthalten sind
	if (newRange.indexOf("+") != -1) {
		alert ("Absolute Zahlen sind nicht mglich.", "Stop");
		exit();
	}
	if (newRange.indexOf("-") != -1) {
		whatKind = whatKind + 1;
	}
	if (newRange.indexOf(",") != -1) {
		whatKind = whatKind + 2;
	}
	// je nach Art der Kette die Listen erstellen
	if (whatKind == 0) {
		pagesList.push(newRange);
	}
	else if (whatKind == 1) {
		var newRangeList = newRange.split("-");
		var startVal = newRangeList[0]*1;
		var stopVal  = (newRangeList[1]*1)+1;
		for (var i=startVal; i<stopVal; i++) {
			pagesList.push(""+i);
		}
	}
	else if (whatKind == 2) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			pagesList.push(newRangeList[i]);
		}
	}
	else if (whatKind == 3) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = tmpItemList[0]*1;
				var stopVal  = (tmpItemList[1]*1)+1;
				for (var k=startVal; k<stopVal; k++) {
					pagesList.push(""+k);
				}
			}
			else {
				pagesList.push(newRangeList[i]);
			}
		}
	}
	
	// prfen, ob die gewnschten Seiten existieren
	var nNum = pagesList.length;
	for (var i=0; i<nNum; i++) {
		var okay = false;
		var actNum = pagesList[i];
		for (var k=0; k<allPageNames.length; k++) {
			if (actNum == allPageNames[k]) {
				okay = true;
				break;
			}
		}
		if (!okay) {
			if (pre) {
				return false;
			}
			else {
				alert ("Die Seite " + actNum + " ist nicht vorhanden.", "Stop");
				exit();
			}
		}
	}
	if (pre) {
		return true;
	}
	else {
		return pagesList;
	}
}

// die Funktion, welche die Farbzuweisung ndert //////////////////////////////////////////////////
function changeColor(oColor, nColor, pNum){
	// alle Objekte der Seite
	var allFrames = curDoc.pages.itemByName(pNum).allPageItems.slice(0);
	// das aktuelle Farbfeld
	var curSwatch = curDoc.swatches.itemByName(nColor);
	// eine Schleife durch die Objekte
	for (var f=0; f<allFrames.length; f++) {
		// eine Einmal-Schleife (wird verlassen wenn Gruppe oder Bild)
		for (var once=0; once<1; once++) {
			// die Art des Objekts
			var curType = allFrames[f].constructor.name;
			if (curType == "Group") {
				break;
			}
			// der Inhaltstyp des Objekts
			try {
				var curCont = allFrames[f].contentType;
			}
			catch (e) {
				break;
			}
			// wenn "Text", dann prfen, ob das Objekt Text auf einem Pfad enthlt
			if (ck08) {
				var curTxtPath = allFrames[f].textPaths[0];
				try {
					if (curTxtPath.texts[0].texts[0].insertionPoints[0].fillColor.name == oColor) {
						curTxtPath.texts[0].texts[0].insertionPoints[0].fillColor = curSwatch;
					}
					curTxtPath.texts[0].contents;
					var curText = curTxtPath.texts[0];
					var allRanges = curText.textStyleRanges;
					// eine Schleife durch die 'text style ranges'
					for (var r=0; r<allRanges.length; r++) {
						// Fllfarbe
						if (ck00) {
							if (allRanges[r].fillColor.name == oColor) {
								allRanges[r].fillColor = curSwatch;
							}
						}
						// Konturfarbe
						if (ck01) {
							if (allRanges[r].strokeColor.name == oColor) {
								allRanges[r].strokeColor = curSwatch;
							}
						}
						// Unterstreichung
						if (ck10) {
							if (allRanges[r].underlineColor.name == oColor) {
								allRanges[r].underlineColor = curSwatch;
							}
							if (ck02) { // Unterstreichung / Lcke
								if (allRanges[r].underlineGapColor.name == oColor) {
									allRanges[r].underlineGapColor = curSwatch;
								}
							}
						}
					}
					if (ck09) {
						var allParas = curText.paragraphs;
						// eine Schleife durch die Abstze
						for (var s=0; s<allParas.length; s++) {
							// Absatzlinie oben und unten 
							replaceRule(allParas[s], oColor, curSwatch);
							// Absatzlinien-Lcke oben und unten
							replaceRuleGap(allParas[s], oColor, curSwatch);
						}
					}
				}
				catch (e) {
				}
			}
			// die Textrahmen
			if (curCont == ContentType.TEXT_TYPE) {
				// Hintergrundfarbe
				if (ck04) {
					if (ck00) {
						replaceFill(allFrames[f], oColor, curSwatch);
					}
					// Konturfarbe
					if (ck01) {
						replaceStroke(allFrames[f], oColor, curSwatch);
					}
					// Farbe fr Lcke
					if (ck02) {
						replaceGap(allFrames[f], oColor, curSwatch);
					}
				}
				var curText = allFrames[f].texts[0];
				if (ck08) {
					if (allFrames[f].texts[0].insertionPoints[0].fillColor.name == oColor) {
						allFrames[f].texts[0].insertionPoints[0].fillColor = curSwatch;
					}
					var allRanges = curText.textStyleRanges;
					// eine Schleife durch die 'text style ranges'
					for (var r=0; r<allRanges.length; r++) {
						// Fllfarbe
						if (ck00) {
							if (allRanges[r].fillColor.name == oColor) {
								allRanges[r].fillColor = curSwatch;
							}
						}
						// Konturfarbe
						if (ck01) {
							if (allRanges[r].strokeColor.name == oColor) {
								allRanges[r].strokeColor = curSwatch;
							}
						}
						// Unterstreichung
						if (ck10) {
							if (allRanges[r].underlineColor.name == oColor) {
								allRanges[r].underlineColor = curSwatch;
							}
							if (ck02) { // Unterstreichung / Lcke
								if (allRanges[r].underlineGapColor.name == oColor) {
									allRanges[r].underlineGapColor = curSwatch;
								}
							}
						}
					}
				}
				if (ck09) {
					var allParas = curText.paragraphs;
					// eine Schleife durch die Abstze
					for (var s=0; s<allParas.length; s++) {
						// Absatzlinie oben und unten 
						replaceRule(allParas[s], oColor, curSwatch);
						// Absatzlinien-Lcke oben und unten
						replaceRuleGap(allParas[s], oColor, curSwatch);
					}
				}
				if (ck07) {
					var allTables = curText.tables;
					for (var t=0; t<allTables.length; t++) {
						// Konturfarbe
						replaceStrokeTable(allTables[t], oColor, curSwatch);
						var allCells = allTables[t].cells;
						// Zellen (Kontur, Hintergrund, Inhalt)
						for (var c=0; c<allCells.length; c++) {
							replaceCellStroke(allCells[c], oColor, curSwatch);
							replaceCellFill(allCells[c], oColor, curSwatch);
							replaceCellText(allCells[c], oColor, curSwatch);
						}
					}
				}
				// Schlagschatten usw.
				if (ck11) {
					replaceDrop(allFrames[f], oColor, curSwatch);
					replaceDropText(allFrames[f], oColor, curSwatch);
				}
			}
			// nicht zugewiesen
			else if (curCont == ContentType.UNASSIGNED) {
				// Linienrahmen
				if (curType == "GraphicLine") {
					if (ck06) {
						// die (unsichtbare) Fllfarbe auf "[Ohne]"
						replaceFill(allFrames[f], oColor, "None");
						// Konturfarbe
						if (ck01) {
							replaceStroke(allFrames[f], oColor, curSwatch);
						}
						// Farbe fr Lcke
						if (ck02) {
							replaceGap(allFrames[f], oColor, curSwatch);
						}
						// Schlagschatten
						if (ck11) {
							replaceDrop(allFrames[f], oColor, curSwatch);
						}
					}
				}
				else {
					if (ck03) {
						// Hintergrundfarbe
						if (ck00) {
							replaceFill(allFrames[f], oColor, curSwatch);
						}
						// Konturfarbe
						if (ck01) {
							replaceStroke(allFrames[f], oColor, curSwatch);
						}
						// Farbe fr Lcke
						if (ck02) {
							replaceGap(allFrames[f], oColor, curSwatch);
						}
						// Schlagschatten
						if (ck11) {
							replaceDrop(allFrames[f], oColor, curSwatch);
						}
					}
				}
			}
			// Bildrahmen
			else if (curCont == ContentType.GRAPHIC_TYPE) {
				if (ck03) {
					// Hintergrundfarbe
					if (ck00) {
						replaceFill(allFrames[f], oColor, curSwatch);
					}
					// Konturfarbe
					if (ck01) {
						replaceStroke(allFrames[f], oColor, curSwatch);
					}
					// Farbe fr Lcke
					if (ck02) {
						replaceGap(allFrames[f], oColor, curSwatch);
					}
					// Schlagschatten
					if (ck11) {
						replaceDrop(allFrames[f], oColor, curSwatch);
					}
				}
			}
		}
	}
}

// Hintergrundfarbe austauschen ///////////////////////////////////////////////////////////////////
function replaceFill(curFrame, oColor, curSwatch) {
	if (curFrame.fillColor.name == oColor) {
		curFrame.fillColor = curSwatch;
	}
}

// Konturfarbe austauschen ////////////////////////////////////////////////////////////////////////
function replaceStroke(curFrame, oColor, curSwatch) {
	if (curFrame.strokeColor.name == oColor) {
		curFrame.strokeColor = curSwatch;
	}
}

// Farbe fr Lcke austauschen ////////////////////////////////////////////////////////////////////
function replaceGap(curFrame, oColor, curSwatch) {
	if (curFrame.gapColor.name == oColor) {
		curFrame.gapColor = curSwatch;
	}
}

// Absatzlinie oben und unten /////////////////////////////////////////////////////////////////////
function replaceRule(curFrame, oColor, curSwatch) {
	if (curFrame.ruleAboveColor.name == oColor) {
		curFrame.ruleAboveColor = curSwatch;
	}
	if (curFrame.ruleBelowColor.name == oColor) {
		curFrame.ruleBelowColor = curSwatch;
	}
}

// Absatzlinien-Lcke oben und unten //////////////////////////////////////////////////////////////
function replaceRuleGap(curFrame, oColor, curSwatch) {
	if (curFrame.ruleAboveGapColor.name == oColor) {
		curFrame.ruleAboveGapColor = curSwatch;
	}
	if (curFrame.ruleBelowGapColor.name == oColor) {
		curFrame.ruleBelowGapColor = curSwatch;
	}
}

// Tabellen-Kontur ////////////////////////////////////////////////////////////////////////////////
function replaceStrokeTable(curFrame, oColor, curSwatch) {
	if (curFrame.topBorderStrokeColor.name == oColor) {
		curFrame.topBorderStrokeColor = curSwatch;
	}
	if (curFrame.leftBorderStrokeColor.name == oColor) {
		curFrame.leftBorderStrokeColor = curSwatch;
	}
	if (curFrame.bottomBorderStrokeColor.name == oColor) {
		curFrame.bottomBorderStrokeColor = curSwatch;
	}
	if (curFrame.rightBorderStrokeColor.name == oColor) {
		curFrame.rightBorderStrokeColor = curSwatch;
	}
	if (curFrame.topBorderStrokeGapColor.name == oColor) {
		curFrame.topBorderStrokeGapColor = curSwatch;
	}
	if (curFrame.leftBorderStrokeGapColor.name == oColor) {
		curFrame.leftBorderStrokeGapColor = curSwatch;
	}
	if (curFrame.bottomBorderStrokeGapColor.name == oColor) {
		curFrame.bottomBorderStrokeGapColor = curSwatch;
	}
	if (curFrame.rightBorderStrokeGapColor.name == oColor) {
		curFrame.rightBorderStrokeGapColor = curSwatch;
	}
}

// Tabellen-Zellen-Konturen ///////////////////////////////////////////////////////////////////////
function replaceCellStroke(curCell, oColor, curSwatch) {
	if (curCell.topEdgeStrokeColor.name == oColor) {
		curCell.topEdgeStrokeColor = curSwatch;
	}
	if (curCell.leftEdgeStrokeColor.name == oColor) {
		curCell.leftEdgeStrokeColor = curSwatch;
	}
	if (curCell.bottomEdgeStrokeColor.name == oColor) {
		curCell.bottomEdgeStrokeColor = curSwatch;
	}
	if (curCell.rightEdgeStrokeColor.name == oColor) {
		curCell.rightEdgeStrokeColor = curSwatch;
	}
	if (curCell.topEdgeStrokeGapColor.name == oColor) {
		curCell.topEdgeStrokeGapColor = curSwatch;
	}
	if (curCell.leftEdgeStrokeGapColor.name == oColor) {
		curCell.leftEdgeStrokeGapColor = curSwatch;
	}
	if (curCell.bottomEdgeStrokeGapColor.name == oColor) {
		curCell.bottomEdgeStrokeGapColor = curSwatch;
	}
	if (curCell.rightEdgeStrokeGapColor.name == oColor) {
		curCell.rightEdgeStrokeGapColor = curSwatch;
	}
}

// Tabellen-Zellen-Hintergrnde ///////////////////////////////////////////////////////////////////
function replaceCellFill(curCell, oColor, curSwatch) {
	if (curCell.fillColor.name == oColor) {
		curCell.fillColor = curSwatch;
	}
}

// Tabellen-Zellen-Inhalt /////////////////////////////////////////////////////////////////////////
function replaceCellText(curCell, oColor, curSwatch) {
	var curText = curCell.texts[0];
	var allRanges = curText.textStyleRanges;
	// eine Schleife durch die 'text style ranges'
	for (var r=0; r<allRanges.length; r++) {
		// Fllfarbe
		if (allRanges[r].fillColor.name == oColor) {
			allRanges[r].fillColor = curSwatch;
		}
		// Konturfarbe
		if (allRanges[r].strokeColor.name == oColor) {
			allRanges[r].strokeColor = curSwatch;
		}
	}
}

// Effekte (Schlagschatten usw.) //////////////////////////////////////////////////////////////////
function replaceDrop(curFrame, oColor, curSwatch) {
	// Objekt / Schlagschatten
	if (curFrame.transparencySettings.dropShadowSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.dropShadowSettings.effectColor = curSwatch;
	}
	// Flche / Schlagschatten
	if (curFrame.fillTransparencySettings.dropShadowSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.dropShadowSettings.effectColor = curSwatch;
	}
	// Kontur / Schlagschatten
	if (curFrame.strokeTransparencySettings.dropShadowSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.dropShadowSettings.effectColor = curSwatch;
	}
	// Objekt / Schatten nach innen
	if (curFrame.transparencySettings.innerShadowSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.innerShadowSettings.effectColor = curSwatch;
	}
	// Flche / Schatten nach innen
	if (curFrame.fillTransparencySettings.innerShadowSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.innerShadowSettings.effectColor = curSwatch;
	}
	// Kontur / Schatten nach innen
	if (curFrame.strokeTransparencySettings.innerShadowSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.innerShadowSettings.effectColor = curSwatch;
	}
	// Objekt / Schein nach aussen
	if (curFrame.transparencySettings.outerGlowSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.outerGlowSettings.effectColor = curSwatch;
	}
	// Flche / Schein nach aussen
	if (curFrame.fillTransparencySettings.outerGlowSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.outerGlowSettings.effectColor = curSwatch;
	}
	// Kontur / Schein nach aussen
	if (curFrame.strokeTransparencySettings.outerGlowSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.outerGlowSettings.effectColor = curSwatch;
	}
	// Objekt / Schein nach innen
	if (curFrame.transparencySettings.innerGlowSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.innerGlowSettings.effectColor = curSwatch;
	}
	// Flche / Schein nach innen
	if (curFrame.fillTransparencySettings.innerGlowSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.innerGlowSettings.effectColor = curSwatch;
	}
	// Kontur / Schein nach innen
	if (curFrame.strokeTransparencySettings.innerGlowSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.innerGlowSettings.effectColor = curSwatch;
	}
	// Objekt / Abgeflachte Kante und Relief / Lichter
	if (curFrame.transparencySettings.bevelAndEmbossSettings.highlightColor.name == oColor) {
		curFrame.transparencySettings.bevelAndEmbossSettings.highlightColor = curSwatch;
	}
	// Objekt / Abgeflachte Kante und Relief / Schatten
	if (curFrame.transparencySettings.bevelAndEmbossSettings.shadowColor.name == oColor) {
		curFrame.transparencySettings.bevelAndEmbossSettings.shadowColor = curSwatch;
	}
	// Flche / Abgeflachte Kante und Relief / Lichter
	if (curFrame.fillTransparencySettings.bevelAndEmbossSettings.highlightColor.name == oColor) {
		curFrame.fillTransparencySettings.bevelAndEmbossSettings.highlightColor = curSwatch;
	}
	// Flche / Abgeflachte Kante und Relief / Schatten
	if (curFrame.fillTransparencySettings.bevelAndEmbossSettings.shadowColor.name == oColor) {
		curFrame.fillTransparencySettings.bevelAndEmbossSettings.shadowColor = curSwatch;
	}
	// Kontur / Abgeflachte Kante und Relief / Lichter
	if (curFrame.strokeTransparencySettings.bevelAndEmbossSettings.highlightColor.name == oColor) {
		curFrame.strokeTransparencySettings.bevelAndEmbossSettings.highlightColor = curSwatch;
	}
	// Kontur / Abgeflachte Kante und Relief / Schatten
	if (curFrame.strokeTransparencySettings.bevelAndEmbossSettings.shadowColor.name == oColor) {
		curFrame.strokeTransparencySettings.bevelAndEmbossSettings.shadowColor = curSwatch;
	}
	// Objekt / Glanz
	if (curFrame.transparencySettings.satinSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.satinSettings.effectColor = curSwatch;
	}
	// Flche / Glanz
	if (curFrame.fillTransparencySettings.satinSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.satinSettings.effectColor = curSwatch;
	}
	// Kontur / Glanz
	if (curFrame.strokeTransparencySettings.satinSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.satinSettings.effectColor = curSwatch;
	}
}

// Text-Effekte (Schlagschatten usw.) //////////////////////////////////////////////////////////////////
function replaceDropText(curFrame, oColor, curSwatch) {
	if (curFrame.contentTransparencySettings.dropShadowSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.dropShadowSettings.effectColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.innerShadowSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.innerShadowSettings.effectColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.outerGlowSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.outerGlowSettings.effectColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.innerGlowSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.innerGlowSettings.effectColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.bevelAndEmbossSettings.highlightColor.name == oColor) {
		curFrame.contentTransparencySettings.bevelAndEmbossSettings.highlightColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.bevelAndEmbossSettings.shadowColor.name == oColor) {
		curFrame.contentTransparencySettings.bevelAndEmbossSettings.shadowColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.satinSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.satinSettings.effectColor = curSwatch;
	}
}